====== inet-3.x ======

2017-10-02  ------ inet-3.6.2 released ------

2017-07-06  ------ inet-3.6.1 released ------

2017-06-09  ------ inet-3.6.0 released ------

2017-06-01  Zoltan Bojthe

	CID 77786 Out-of-bounds read

2017-06-01  Zoltan Bojthe

	CID 179285 Logical vs. bitwise operator, code indentation

2017-02-20  ------ inet-3.5.0 released ------

2016-11-24  Irene Ruengeler

	Packetdrill: Add StreamReconfig support for SCTP

2016-09-22  Zoltan Bojthe

	omnetpp5: add/use refreshDisplay()

2016-07-20  Zoltan Bojthe

	omnetpp5: replace deprecated cQueue functions: operator(), length(),
	empty()

2016-06-15  ------ inet-3.4.0 released ------

2016-06-01  ------ inet-3.3.0 released ------

2016-06-01  Irene Rungeler

	sctp: Added support for the SCTP_ACCEPT command.

2016-05-11  Rudolf Hornig

  sctp: refactor: use c++11 style for loop
	sctp: Reverted some logging changes

2016-03-30  Irene Ruengeler

	Packetdrill SCTP support and socket options added

2016-04-06  ------ inet-3.2.4 released ------

2016-03-16  ------ inet-3.2.3 released ------

2016-03-11  ------ inet-3.2.2 released ------

2016-01-21  ------ inet-3.2.1 released ------

2015-12-16  ------ inet-3.2.0 released ------

2015-11-26  Andras Varga

	Made the code compile with OMNeT++ 5.0b3

2015-10-26  ------ inet-3.1.1 released ------

2015-10-15  ------ inet-3.1.0 released ------

2015-06-22  ------ inet-3.0.0 released ------

2015-05-13  ------ inet-2.99.1 released ------

2015-04-24  Irene Ruengeler

	Set the primary path when the path is established.
	Do not update a sockPair that is already stored.

2015-04-24  Thomas Dreibholz

	Bugfix for SCTPAssociation::process_RCV_Message(): After
	"sctpMain->removeAssociation(this);", a return is necessary. Otherwise,
	the not-any-longer-existing association will cause a segfault due to
	access to already-free'd memory at the end of the method.

2015-04-17  Thomas Dreibholz

	Fixed signed/unsigned warnings.

2015-04-16  Thomas Dreibholz

	Fixed wrong usage of cPacket by replacing with cMessage.

2015-04-10  Thomas Dreibholz

	Also send SCTP_I_SENDQUEUE_FULL indication for unordered messages.

2015-03-13  Irene Ruengeler

	Set length according to address type.

2015-03-10  Irene Ruengeler

	Fixed unknown define.

2015-03-10  Irene Ruengeler

	Fixed bug concerning different sizes for written bytes and getByteLength.

2015-03-20  Irene Ruengeler

	Look up addresses in Init-Ack chunk to verify source address.

2015-03-11  Thomas Dreibholz

	Set sctpMsg to NULL after delete.

2015-03-11  Thomas Dreibholz

	If we are not on the primary path, and there is a small chunk to send
	(bytesToSend > 0), and Nagle turned on: leave inner loop. Otherwise,
	there will be an infinite loop!

2015-03-11  Thomas Dreibholz

	Bugfix: set sctpMsg to NULL for invalidating pointer.

2015-03-11  Thomas Dreibholz

	Bugfix: need to create new SCTPMessage when necessary.

2015-03-11  Thomas Dreibholz

	Bugfix: set sctpMsg to NULL after sendSACKviaSelectedPath().

2015-03-11  Thomas Dreibholz

	Safety check in send loop to avoid endless loops.

2015-03-11  Thomas Dreibholz

	Fixed storePacket()/loadPacket().

2015-03-19  Irene Ruengeler

	Look up addresses in Init-Ack chunk to verify source address

2015-03-18  Levente Meszaros

	Transport: Added ITransportPacket interface to TCPSegment, UDPPacket, and
	SCTPMessage. This change allows generic handling of transport packets. For
	example, see TunLoopbackApp.

2015-03-16  Thomas Dreibholz

	CC function initialisation bugfix: need to initialise function to call
	before SACK.

2015-03-16  Irene Ruengeler

	Arithmetic for removal of chunk was wrong.

2015-01-30  Irene Ruengeler

	Added fragPoint parameter to limit the size of fragments.
	Added data chunk header length.
	After the handshake only send heartbeats on unconfirmed paths.
	Handle close command, i.e. stop reading when the command is sent.

2015-01-21  Irene Ruengeler

	Fixed defects found by static code analyzer (Coverity).

2015-01-21  Zoltan Bojthe

	Applied C++ source code modernizer.

2014-11-07  ------ inet-2.99.0 released ------

2014-09-18  Andras Varga

	Moved all sources under the src/inet directory, so that all #include
	statements begin with "inet/". The motivation is to rule out potential
	filename clashes when multiple model frameworks are used together.

	HINT: You can use the "opp_githist" command in inet/_scripts to find
	all previous locations of the sources in this directory, and to view
	the full history in gitk. Normal invocations of gitk can only show
	file history back to the most recent move operation.

2014-07-30  Andras Varga

	Changes on the inet-3.x branch so far:

	Code formatting (Zoltan Bojthe)
	- using uncrustify, see _scripts/reformat/*
	- common style for header guards

	Namespace (Zoltan Bojthe, Zsolt Prontvai)
	- code has been moved into the inet namespace

	Init stages (Zoltan Bojthe, Andras Varga)
	- init stages: reorganized by layers

	Signals (Zoltan Bojthe)
	- replace INotifiable and NotificationBoard by signals for
	  publish/subscribe communication

	Logging (Zoltan Bojthe, Benjamin Seregi)
	- EV log statements revised and categorized: EV_ERROR, EV_WARN,
	  EV_INFO, EV_DETAIL, EV_DEBUG, EV_TRACE

====== inet-2.x ======

2015-03-04  ------ inet-2.6 released ------

2015-03-05  Martin Becke

	added OLIA for CMT-SCTP

2014-11-07  ------ inet-2.5.1 released ------

2014-10-29  ------ inet-2.5.0 released ------

2014-06-12  ------ inet-2.4.0 released ------

2014-03-19  ------ inet-2.3.0 released ------

2014-03-18  Irene Rungeler

	sctp: added SCTP/IPv6 support

2014-03-14  Irene Rungeler

	sctp: added SCTP NAT support

2014-03-13  Rudolf Hornig

	SCTP: CMT (Concurrent Multipath Transfer) for SCTP by Thomas Dreibholz

2014-01-24  Zoltan Bojthe

	backport: fix access-after-send of msg objects (it's illegal)

	- OrdinalBasedDuplicator: fixed order of emit(packet) / send(packet)
	- SCTP: sctpmsg was used after send

2014-01-15  Zoltan Bojthe

	backported registerProtocol

2013-09-20  Andras Varga

	ev->EV and related OMNeT++ 5.0 logging compatible fixes

2013-08-22  ------ inet-2.2.0 released ------

2013-08-08  Irene Ruengeler

	Code refactoring, output/logging changes, minor fixes

2013-07-29  Irene Ruengeler

	 Added the packet drop feature  (draft-stewart-sctp-pktdrprep-15.txt),
	 the "sack immediately" feature (draft-ietf-tsvwg-sctp-sack-immediately)
	 and several alternatives to send fast retransmissions.

2013-07-17  Irene Ruengeler

	Added 8 new strategies for stream scheduling
	Patch for more statistics and better flow control.

2013-07-15  Irene Ruengeler

	Implemented SCTP Stream Reset (RFC 6525)

2013-07-11  Irene Ruengeler

	Implemented SCTP Authentication (RFC 4895).

2013-07-08  Irene Ruengeler

	Implemented Add-IP feature for SCTP (RFC 5061).

2013-06-21  Irene Ruengeler

	Implemented NR_SACK feature, which is necessary for handling reneging
	especially when using CMT.

	Implemented Partial Reliability SCTP (RFC 3758)

2013-02-20  Andras Varga

	const fixes (in OMNeT++ 5.0, check_and_cast<> no longer silently
	discards const modifier)

2013-01-30  ------ inet-2.1.0 released ------

2012-08-07  ------ inet-2.0.0 released ------

2012-06-25  ------ inet-1.99.5 released ------

2012-03-20  ------ inet-1.99.4 released ------

2012-02-24  ------ inet-1.99.3 released ------

2012-01-18  Zoltan Bojthe

	SCTP: getAddressLevel optimalization: call only once

2012-01-18  Andras Varga

	getAddressLevel() moved from common.cc to the SCTP code

	That was its only usage; "address level" as a concept doesn't appear to
	be universally useful.

2012-01-18  Andras Varga

	common: getLevel() --> getAddressLevel(); refinements on categorization

	IPv4: BROADCAST should probably be on level 0 per analogy with IPv6;
	IETF, TEST_NET, RESERVED are unused or special-purpose, probably better
	on level 0 as well.

2011-11-18  ------ INET-1.99.2 released ------

2011-11-18  Zoltan Bojthe

	NEDDOC fixes

2011-11-13  Andras Varga

	minor: use dropAndDelete() instead of drop()+delete [ZBojthe]

2011-11-13  Levente Meszaros, Zoltan Bojthe

	Refactored operator= and copy constructor in all INET classes.
	See base/ChangeLog for details.

2011-09-15  Zoltan Bojthe

	Fixes for ev.disable_tracing

	Also copied back old updateDisplayString() function to SCTP

2011-11-04  Zoltan Bojthe

	eliminate some warnings: variable set but not used

2011-07-28  Andras Varga

	UDP apps: change to UDPSocket; updated for the UDP API changes

2011-07-19  Andras Varga

	cPolymorphic -> cObject (cPolymorphic became cObject in OMNeT++ 4.0)

2011-06-03  Andras Varga

	cosmetics: space usage made somewhat more consistent throughout the code

	Notes:
	- if you have an INET fork and want to compare the code, use the
	 "Ignore spaces" option of your visual diff tool. Most tools have
	 this option; Meld and Araxis Merge certainly do.

	- I used omnetpp/_scripts/tidymodel/spaces.pl, plus some manual tweaks

2011-05-30  ------ INET-1.99.1 released ------

2011-05-27  Andras Varga

	tab-to-space in all source files

2011-05-26  Zoltan Bojthe

	Renamed IP... classes to IPv4... or IPvX...

2011-05-11  Rudolf Hornig

	Moved header serializers to the util directory.

2011-03-29  Zoltan Bojthe

	featuresupport: add ETHERNET feature

2011-03-17  Zoltan Bojthe

	Features: SCTP

	Require from IPv4 code styling

2011-03-11  Zoltan Bojthe

	Features: UDP (and SCTP)

2011-03-08  Zoltan Bojthe

	Features: SCTP changes

2011-03-08  Zoltan Bojthe

	Features: SCTP

2011-03-04  Zoltan Bojthe

	Features: Move RSVP / SCTP related functions from util/common.cc to
	feature-specific directory

2011-03-04  Zoltan Bojthe

	Features: add more features

2011-03-03  Zoltan Bojthe

	features: TCP_NSC, TCP_lwip, IPv6 completed

2011-03-03  ------ INET-1.99.0 released ------

2011-03-02  Zoltan Bojthe

	change opp_error to throw cRuntimeError

2011-01-03  Alberto Cortes

	Fix SCTP Path.Max.Retrans threshold

	RFC4960 section 8.2, second paragraph, says:

	   When the value in the error counter exceeds the protocol parameter
	  'Path.Max.Retrans' of that destination address, the endpoint should
	  mark the destination transport address as inactive, and a
	  notification SHOULD be sent to the upper layer.

	But old code marks the address as inactive when the error counter is
	*equal* to Path.Max.Retrans instead of when it *exceeds* it. This bug
	leads to make premature handovers (about half the time of what it should
	be, due to the exponential grow of the RTO between retransmissions).

2011-02-22  Andras Varga

	Swiched NED documentation comments to explicit hyperlinking of NED
	type names, using tilde. Example: "TCP" was changed to "~TCP"
	wherever the module and not the protocol was meant.

	The reason for the switch was that autolinking produced too many
	false hits (e.g. "TCP connection" and "IP address" would link
	to the TCP and IP modules.)

2011-01-13  Zoltan Bojthe

	using getEncapsulatedPacket() instead deprecated getEncapsulatedMsg()

2010-10-18  Alberto Cortés

	Add scalars & vectors to SCTP for HBs & HB-ACKs

	4 new scalars keep track of the number of Heartbeats and Heartbeat-ACKs
	sent and received on each path. The vectors hold the time when they were
	sent or received.

2010-12-06  Rudolf Hornig

	Reverting previous commit.

2010-10-29  Rudolf Hornig

	Added some addinitinal statistics to SCTP

2010-10-18  Alberto Cortés

	Change some castings to check_and_cast

2010-10-07  Alberto Cortés

	Add "sent TSN" vector recording to SCTP

	SCTP already defines the vector pathTSN for recording the sent TSNs, but
	it was never used. This patch makes SCTP do the actual recording.

2010-05-21  Andras Varga

	SCTP compile fixes for msvc

2010-04-26  Rudolf Hornig

	Fixed an SCTP bug when primary path fails but the server continues to
	send ACKS on the primary path.

	Patch by Antonio M. Macías Ojeda reviewed by Irene Ruengeler

2010-04-16  Rudolf Hornig

	SCTP fix by Irene Rungeler

2010-03-26  Andras Varga

	UDP,TCP fix: port numbers were represented with (signed) short at
	places; SCTP: minor related change

	Signed short caused problems for large port numbers due to sign
	extension (see ASSERT(conn->localPort == localPort) in TCP.cc)
	[reported by Thomas Gamer]

2010-03-12  Rudolf Hornig

	Fixed compilation on windows. Unnecessary pthread references were
	removed from TCP dump too.

2010-03-11  Rudolf Hornig

	Added SCTP patch from Irene Rungeler.

2010-01-28  Zoltan Bojthe

	add FIXME suggest parentheses

2009-11-05  Rudolf Hornig

	Changes related to the TCP-SACK implementation from Thomas Reschka.

2009-08-26  Andras Varga

	cosmetics (warnings, tab-to-space, reindent, typos, dead code removal)

2009-07-18  Andras Varga

	more gate labels added; also, fixed case of TCPOut gates (i.e. they got
	renamed to tcpOut)

2009-07-17  Levente Meszaros

	Added labels to gates to so that the graphical editor can match them
	when the user creates a connection:

	@labels(EtherFrame); labels(Ieee802Ctrl/up); labels(Ieee802Ctrl/down);
	@labels(TCPCommand/up); @labels(TCPCommand/down);
	@labels(UDPControlInfo/up); @labels(UDPControlInfo/down);
	@labels(Ieee80211Frame);  @labels(IPControlInfo/down);
	@labels(IPControlInfo/up);  @labels(IPDatagram);
	@labels(IPv6ControlInfo/up); @labels(IPv6ControlInfo/down);
	@labels(IPv6Datagram)

2009-03-25  ------ INET-20090325 released ------

2009-03-05  Irene Ruengeler

	change default parameter for gaps

2008-09-25  Irene Ruengeler

	Initial version.

	If you are interested in the early history of the SCTP code, change
	to the project root and type

	$ gitk -- INET/src/transport/sctp
